#include <algorithm>
#include <iostream>
#include <list>
#include <map>
#include <string>
#include <utility>
#include <vector>

void vectorTest() {
  std::vector<int> v1;

  std::cout << "The vector v1 has " << v1.size() << " elements. They are : ";
  for (auto &i : v1)
    std::cout << i << " ";
  std::cout << std::endl;

  v1.push_back(0);

  std::cout << "The vector v1 has " << v1.size() << " elements. They are : ";
  for (auto &i : v1)
    std::cout << i << " ";
  std::cout << std::endl;

  v1.push_back(1);

  std::cout << "The vector v1 has " << v1.size() << " elements. They are : ";
  for (auto &i : v1)
    std::cout << i << " ";
  std::cout << std::endl;

  v1.push_back(2);
  v1.push_back(3);
  v1.push_back(4);
  v1.push_back(5);

  std::cout << "The vector v1 has " << v1.size() << " elements. They are : ";
  for (auto &i : v1)
    std::cout << i << " ";
  std::cout << std::endl;

  v1[0] = 100;

  std::cout << "The vector v1 has " << v1.size() << " elements. They are : ";
  for (auto &i : v1)
    std::cout << i << " ";
  std::cout << std::endl;

  std::cout << "The back() element is " << v1.back() << " and after a call is " << v1.back() << "\n";

  v1.pop_back();

  std::cout << "The vector v1 has " << v1.size() << " elements. They are : ";
  for (auto &i : v1)
    std::cout << i << " ";
  std::cout << std::endl;

  // Print out all elements
  for (std::vector<int>::size_type i = 0; i < v1.size(); ++i) {
    std::cout << v1[i] << " ";
  }
  std::cout << "\n";

  for (std::vector<int>::iterator i = v1.begin(); i != v1.end(); ++i) {
    std::cout << *i << " ";
  }
  std::cout << "\n";

  for (int i : v1) {
    std::cout << i << " ";
  }
  std::cout << "\n";

  std::sort(v1.begin(), v1.end());

  std::cout << "After std::sort: ";
  for (int i : v1) {
    std::cout << i << " ";
  }
  std::cout << "\n";

  // Another way to create a vector
  std::vector<int> v2{{ 0, 1, 2, 3, 4, 5}};
}

void listTest() {
  std::list<int> l1;

  std::cout << "The list l1 has " << l1.size() << " elements. They are : ";
  for (auto &i : l1)
    std::cout << i << " ";
  std::cout << std::endl;

  l1.push_back(0);

  std::cout << "The list l1 has " << l1.size() << " elements. They are : ";
  for (auto &i : l1)
    std::cout << i << " ";
  std::cout << std::endl;

  l1.push_back(1);

  std::cout << "The list l1 has " << l1.size() << " elements. They are : ";
  for (auto &i : l1)
    std::cout << i << " ";
  std::cout << std::endl;

  l1.push_back(2);
  l1.push_back(3);
  l1.push_back(4);
  l1.push_back(5);

  std::cout << "The list l1 has " << l1.size() << " elements. They are : ";
  for (auto &i : l1)
    std::cout << i << " ";
  std::cout << std::endl;

  l1.push_front(100);

  std::cout << "The list l1 has " << l1.size() << " elements. They are : ";
  for (auto &i : l1)
    std::cout << i << " ";
  std::cout << std::endl;

  std::cout << "The back() element is " << l1.back() << " and after a call is " << l1.back() << "\n";

  l1.pop_back();

  std::cout << "The list l1 has " << l1.size() << " elements. They are : ";
  for (auto &i : l1)
    std::cout << i << " ";
  std::cout << std::endl;

  // Print out all elements
  for (std::list<int>::iterator i = l1.begin(); i != l1.end(); ++i) {
    std::cout << *i << " ";
  }
  std::cout << "\n";

  for (int i : l1) {
    std::cout << i << " ";
  }
  std::cout << "\n";

  //std::sort(l1.begin(), l1.end());
  l1.sort();

  std::cout << "After std::sort: ";
  for (int i : l1) {
    std::cout << i << " ";
  }
  std::cout << "\n";

}

void mapTest() {
  std::map<int, std::string> m1;

  m1.insert(std::make_pair<int, std::string>(1, "1 string"));
  m1.insert(std::make_pair(2, "2 string"));
  m1[3] = "3 string";

  // side note: (*i).first  equivalent to i->first

  for (auto i : m1) {
    std::cout << "key = " << i.first << " value = " << i.second << "\n";
  }

  std::map<int, std::vector<int>> m2;

  m2.insert(std::make_pair(1, std::vector<int>{{ 1 }}));
  m2.insert(std::make_pair<int, std::vector<int>>(2, {{ 2 }}));
  for (auto i : m2) {
    std::cout << "key = " << i.first << " values = ";
    for (auto j : i.second) {
      std::cout << j << " ";
    }
    std::cout << "\n";
  }

  if (m2.find(1) != m2.end()) {
    m2[1].push_back(1);
  }

  for (auto i : m2) {
    std::cout << "key = " << i.first << " values = ";
    for (auto j : i.second) {
      std::cout << j << " ";
    }
    std::cout << "\n";
  }

  m2[3].push_back(3);
  m2[3] = std::vector<int>{{4}};

  for (auto i : m2) {
    std::cout << "key = " << i.first << " values = ";
    for (auto j : i.second) {
      std::cout << j << " ";
    }
    std::cout << "\n";
  }

}

int main() {
  //vectorTest();
  ///listTest();
  mapTest();

  return 0;
}
